//+------------------------------------------------------------------+
//|                      Copyright c 2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+--------------------------Tsyrus----------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 5
//#property indicator_color1 Red
//#property indicator_color2 White
//#property indicator_color3 Red
//#property indicator_color4 White
#property indicator_color5 LawnGreen
//#property indicator_width1 1
//#property indicator_width2 1
//#property indicator_width3 3
//#property indicator_width4 3
#property indicator_width5 2

//----
//extern color color1 = Red;
//extern color color2 = White;
//extern color color3 = Red;
//extern color color4 = White;
extern color color5 = LawnGreen;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   //SetIndexStyle(0,DRAW_HISTOGRAM, 0, 1, color1);
   //SetIndexBuffer(0, ExtMapBuffer1);
   //SetIndexStyle(1,DRAW_HISTOGRAM, 0, 1, color2);
   //SetIndexBuffer(1, ExtMapBuffer2);
   //SetIndexStyle(2,DRAW_HISTOGRAM, 0, 3, color3);
   //SetIndexBuffer(2, ExtMapBuffer3);
   //SetIndexStyle(3,DRAW_HISTOGRAM, 0, 3, color4);
   //SetIndexBuffer(3, ExtMapBuffer4);
   SetIndexStyle(4,DRAW_HISTOGRAM, 0, 2, color5);
   SetIndexBuffer(4, ExtMapBuffer5);
//----
   //SetIndexDrawBegin(0,10);
   //SetIndexDrawBegin(1,10);
   //SetIndexDrawBegin(2,10);
   //SetIndexDrawBegin(3,10);
   SetIndexDrawBegin(4,10);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double haOpen, haHigh, haLow, haClose;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
      haOpen=(ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
      haClose=(Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
      haHigh=MathMax(High[pos], MathMax(haOpen, haClose));
      haLow=MathMin(Low[pos], MathMin(haOpen, haClose));
      if (haOpen<haClose) 
        {
         //ExtMapBuffer1[pos]=haLow;
         //ExtMapBuffer2[pos]=haHigh;
        } 
      else
        {
         //ExtMapBuffer1[pos]=haHigh;
         //ExtMapBuffer2[pos]=haLow;
        } 
      ExtMapBuffer3[pos]=haOpen;
      ExtMapBuffer4[pos]=haClose;
      ExtMapBuffer5[pos]=(haClose-haOpen)*10000;
 	   pos--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+